package main

import (
	"fmt"
	"sync"
)

func main() {
	var once sync.Once // 需要传递一个函数进去
	fmt.Printf("%T %#v\n", once, once)

	for i := 0; i < 10; i++ {
		once.Do(func() {
			fmt.Println(i)
		})
	}

	// Output:
	//sync.Once sync.Once{done:0x0, m:sync.Mutex{state:0, sema:0x0}}
	//0
}
